#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    //cin.tie(0);

    int n, q;
    vector<int> a;
    cin >> n >> q;

    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        a.push_back(x);
    }

    for (int i = 0; i < q; i++) {
        int l, r;
        cin >> l >> r;

        int val = a[l - 1];
        cout << a[l - 1] << ' ';

        for (int j = l + 1; j <= r; j++) {
            cout << a[j - 1] << ' ';
            val &= a[j - 1];
        }

        cout << val << '\n';
    }

    return 0;
}